Index: trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp
===================================================================
--- trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 134)
+++ trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 140)
@@ -1887,20 +2795,20 @@
                             for(size_t i=0; i<m_dcache_words; i++){
                                 data_t rdata = 0;
-                                r_dcache.read(ad + i*4,&rdata);
+                                r_dcache[num_cache]->read(ad + i*4,&rdata);
                                 data_t mask = vci_param::be2mask(r_tgt_be[i]);
                                 r_tgt_buf[i] = (mask & r_tgt_buf[i]) | (~mask & rdata);
                             }
-                            r_dcache_fsm = DCACHE_CC_UPDT;
+                            r_dcache_fsm[num_cache] = DCACHE_CC_UPDT;
 #endif //CC_XCACHE_WRAPPER_CC_UPDATE_MULTI_CYCLE
                         } else if ( dcache_hit and not r_tgt_update ) {
-                            r_dcache_fsm = DCACHE_CC_INVAL;
+                            r_dcache_fsm[num_cache] = DCACHE_CC_INVAL;
                         } else {
                             if(r_tgt_update){
-                                r_tgt_dcache_rsp = true;
+                                r_tgt_dcache_rsp[num_cache] = true;
                             } else {
-                                r_tgt_dcache_rsp = false;
+                                r_tgt_dcache_rsp[num_cache] = false;
                             }
-                            r_tgt_dcache_req = false;
-                            r_dcache_fsm = r_dcache_fsm_save;
+                            r_tgt_dcache_req[num_cache] = false;
+                            r_dcache_fsm    [num_cache] = r_dcache_fsm_save[num_cache];
                         }
                     }
@@ -1910,5 +2818,5 @@
             case DCACHE_CC_UPDT:    // update directory and data cache        
                 {
-                    addr_40 ad = r_tgt_addr;
+                    addr_40 ad = r_tgt_daddr;
 
                     m_cpt_dcache_dir_write++;
@@ -1923,9 +2831,9 @@
                     
                     if(r_tgt_be[word])
-                        r_dcache.write(ad+word*4, r_tgt_buf[word]);
+                        r_dcache[num_cache]->write(ad+word*4, r_tgt_buf[word]);
 # ifdef COHERENCE_DEBUG
                     std::cout << " address " << std::hex << ad+word*4 << " data " << std::dec << r_tgt_buf[word] << std::endl;
                     data_t rdata = 0xAAAAAAAA;
-                    r_dcache.read(ad+word*4,&rdata);
+                    r_dcache[num_cache]->read(ad+word*4,&rdata);
                     std::cout << "data written " << rdata << std::endl; 
 # endif
@@ -1940,7 +2848,7 @@
                     if (word==m_dcache_words)
                     {
-                        r_tgt_dcache_req = false;
-                        r_tgt_dcache_rsp = true;
-                        r_dcache_fsm = r_dcache_fsm_save;
+                        r_tgt_dcache_req[num_cache] = false;
+                        r_tgt_dcache_rsp[num_cache] = true;
+                        r_dcache_fsm    [num_cache] = r_dcache_fsm_save[num_cache];
                         word = 0;
                     }
@@ -1950,16 +2858,16 @@
                     for(size_t i=0; i<m_dcache_words; i++){
                         if(r_tgt_be[i]) {
-                            r_dcache.write( ad + i*4, buf[i]);
+                            r_dcache[num_cache]->write( ad + i*4, buf[i]);
 # ifdef COHERENCE_DEBUG
                             std::cout << " address " << std::hex << ad+i*4 << " data " << std::dec << buf[i] << std::endl;
                             data_t rdata = 0xAAAAAAAA;
-                            r_dcache.read(ad + i*4,&rdata);
+                            r_dcache[num_cache]->read(ad + i*4,&rdata);
                             std::cout << "data written " << rdata << std::endl; 
 # endif //CC_XCACHE_WRAPPER_CC_UPDATE_MULTI_CYCLE
                         }
                     }
-                    r_tgt_dcache_req = false;
-                    r_tgt_dcache_rsp = true;
-                    r_dcache_fsm = r_dcache_fsm_save;
+                    r_tgt_dcache_req[num_cache] = false;
+                    r_tgt_dcache_rsp[num_cache] = true;
+                    r_dcache_fsm    [num_cache] = r_dcache_fsm_save[num_cache];
 #endif
                     break;
@@ -1968,9 +2876,9 @@
             case DCACHE_CC_INVAL:   // invalidate a cache line
                 {
-                    addr_40  ad      = r_tgt_addr;
-                    r_tgt_dcache_rsp = true;
-                    r_dcache.inval(ad);
-                    r_tgt_dcache_req = false;
-                    r_dcache_fsm = r_dcache_fsm_save;
+                    addr_40  ad      = r_tgt_daddr;
+                    r_tgt_dcache_rsp[num_cache] = true;
+                    r_dcache        [num_cache]->inval(ad);
+                    r_tgt_dcache_req[num_cache] = false;
+                    r_dcache_fsm    [num_cache] = r_dcache_fsm_save[num_cache];
                     break;
                 }
@@ -1979,15 +2887,19 @@
                 {
                     // external cache invalidate request
-                    if ( r_tgt_dcache_req )   
+                    if ( r_tgt_dcache_req[num_cache] )   
                     {
-                        r_dcache_fsm = DCACHE_CC_CHECK;
-                        r_dcache_fsm_save = r_dcache_fsm;
+                        r_dcache_fsm     [num_cache] = DCACHE_CC_CHECK;
+                        r_dcache_fsm_save[num_cache] = r_dcache_fsm[num_cache];
                         break;
                     }        
                     // cleanup
-                    if(not r_dcache_cleanup_req){
-                        r_dcache_cleanup_req = true;
-                        r_dcache_cleanup_line = r_dcache_addr_save.read() >> m_dcache_words_shift;
-                        r_dcache_fsm = DCACHE_IDLE;
+                    if(not r_dcache_cleanup_req[num_cache]){
+                        r_dcache_cleanup_req  [num_cache] = true;
+                        r_dcache_cleanup_line [num_cache] = r_dcache_addr_save[num_cache].read() >> m_dcache_words_shift;
+                        r_dcache_fsm          [num_cache] = DCACHE_IDLE;
+
+                        // FIXME : too many access at the cache in this cycle
+                        m_cpt_dcache_dir_read += m_dcache_ways;
+                        r_dcache[num_cache]->inval((addr_40)r_dcache_addr_save[num_cache]);
                     }
                     break;
@@ -1999,94 +2911,135 @@
         // The update() method must be called at each cycle to update the internal state.
         // All pending write requests must be locked in case of SYNC
-        bool wbuf_flush=(r_dcache_fsm == DCACHE_SYNC);
+
+        // bool have_sync=(r_dcache_fsm[num_cache] == DCACHE_SYNC);
 #if   (CC_XCACHE_WRAPPER_WBUF_UPDATE_SCHEME==1)
-        r_wbuf.update_multi_scan      (wbuf_flush);
+        r_wbuf[num_cache]->update_multi_scan      (have_sync);
 #elif (CC_XCACHE_WRAPPER_WBUF_UPDATE_SCHEME==2)
-        r_wbuf.update_round_robin_scan(wbuf_flush);
+        r_wbuf[num_cache]->update_round_robin_scan(have_sync);
 #elif (CC_XCACHE_WRAPPER_WBUF_UPDATE_SCHEME==3)
-        r_wbuf.update_one_scan        (wbuf_flush);
+        r_wbuf[num_cache]->update_one_scan        (have_sync);
 #else
-        r_wbuf.update                 (wbuf_flush);
+        r_wbuf[num_cache]->update                 (have_sync);
+#endif
+
+        drsp [num_cache] = _drsp;
+        if (_dreq.valid and _drsp.valid)
+        {
+            PRINTF("    * <CPU2CACHE> Transaction between cpu %d and Dcache %d (unlock)\n",r_dcache_lock [num_cache].read(),num_cache);
+
+            r_dcache_lock       [num_cache] = m_nb_cpu;
+            m_cpt_dcache_access [num_cache] ++;
+        }
+
+        }// end for num_cache
+
+        /////////// execute one iss cycle /////////////////////////////////////////////
+
+        for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+        {
+            // Test if the resquest is accepted
+            typename iss_t::InstructionResponse _irsp = ISS_IRSP_INITIALIZER;
+            typename iss_t::DataResponse        _drsp = ISS_DRSP_INITIALIZER;
+
+            if (ireq_num_cache[num_cpu]<m_nb_icache)
+                _irsp = irsp[ireq_num_cache[num_cpu]];
+            if (dreq_num_cache[num_cpu]<m_nb_dcache)
+                _drsp = drsp[dreq_num_cache[num_cpu]];
+
+#if CC_XCACHE_WRAPPER_STOP_SIMULATION  or CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+            typename iss_t::InstructionRequest  _ireq = ISS_IREQ_INITIALIZER;
+            typename iss_t::DataRequest         _dreq = ISS_DREQ_INITIALIZER;
+
+            if (ireq_num_cache[num_cpu]<m_nb_icache)
+                _ireq = ireq[ireq_num_cache[num_cpu]];
+            if (dreq_num_cache[num_cpu]<m_nb_dcache)
+                _dreq = dreq[dreq_num_cache[num_cpu]];
 #endif
 
 #if CC_XCACHE_WRAPPER_DEBUG
-        if (m_cpt_total_cycles>=CC_XCACHE_WRAPPER_DEBUG_CYCLE_MIN)
-            std::cout << "    * Data        Response : " << drsp << std::endl;
-#endif
-
-        /////////// execute one iss cycle /////////////////////////////////////////////
-        {
-            uint32_t it = 0;
-            for (size_t i=0; i<(size_t)iss_t::n_irq; i++) 
-                if(p_irq[i].read()) it |= (1<<i);
-            m_iss.executeNCycles(1, irsp, drsp, it);
-        }
-
-        if ( (ireq.valid and not irsp.valid) or 
-             (dreq.valid and not drsp.valid))
-        {
-            m_cpt_frz_cycles++;
+            if (m_cpt_total_cycles>=CC_XCACHE_WRAPPER_DEBUG_CYCLE_MIN)
+            {
+
+                std::cout << "    * CPU                    : " << num_cpu << std::endl
+                          << "      * Instruction Cache    : " << ireq_num_cache[num_cpu] << ", valid : " << (ireq_num_cache[num_cpu]<m_nb_icache) << std::endl
+                          << "      * Instruction Request  : " << _ireq << std::endl
+                          << "      * Instruction Response : " << _irsp << std::endl
+                          << "      * Data        Cache    : " << dreq_num_cache[num_cpu] << ", valid : " << (dreq_num_cache[num_cpu]<m_nb_dcache) << std::endl
+                          << "      * Data        Request  : " << _dreq << std::endl
+                          << "      * Data        Response : " << _drsp << std::endl;
+            }
+#endif
+
+            if ((_ireq.valid and not _irsp.valid) or 
+                (_dreq.valid and not _drsp.valid))
+            {
+                m_cpt_frz_cycles [num_cpu]++;
 #if CC_XCACHE_WRAPPER_STOP_SIMULATION
-            m_stop_simulation_nb_frz_cycles ++;
+                m_stop_simulation_nb_frz_cycles [num_cpu]++;
+                
+                if (m_stop_simulation and (m_stop_simulation_nb_frz_cycles [num_cpu]>= m_stop_simulation_nb_frz_cycles_max))
+                {
+                    std::cout << std::dec << "CC_XCACHE_WRAPPER \"" << name() << "\" (" << num_cpu << ") : cycle " << m_cpt_total_cycles << ", the cpu is frozen since " << m_stop_simulation_nb_frz_cycles [num_cpu]<< " cycles." << std::endl;
+                    ASSERT(false,"CPU : anormal activity"); // exit
+                }
+            }
+            else
+            {
+                m_stop_simulation_nb_frz_cycles [num_cpu] = 0; // reinit counter
+#endif //CC_XCACHE_WRAPPER_STOP_SIMULATION
+            }
             
-            if (m_stop_simulation and (m_stop_simulation_nb_frz_cycles >= m_stop_simulation_nb_frz_cycles_max))
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+            if (_ireq.valid and _irsp.valid)
             {
-                std::cout << std::dec << "CC_XCACHE_WRAPPER \"" << name() << "\" : cycle " << m_cpt_total_cycles << ", the cpu is frozen since " << m_stop_simulation_nb_frz_cycles << " cycles." << std::endl;
-                ASSERT(false,"CPU : anormal activity"); // exit
+                log_transaction_file_icache [num_cpu]
+                    << "[" << m_cpt_total_cycles << "]"
+                    << std::hex
+                    << " @ "     << std::setw(8) << (uint32_t)_ireq.addr
+                    << " ("      << std::setw(8) << (uint32_t)set_num_icache_only(_ireq.addr,ireq_num_cache[num_cpu]) 
+                    << " - L "     << std::setw(8) <<((uint32_t)set_num_icache_only(_ireq.addr,ireq_num_cache[num_cpu])&m_icache_yzmask) << ")"
+                    << " I "     << std::setw(8) << (uint32_t)_irsp.instruction
+                    << " error "                 << (uint32_t)_irsp.error
+                    << std::dec
+                    << std::endl;
             }
-        }
-        else
-        {
-            m_stop_simulation_nb_frz_cycles = 0; // reinit counter
-#endif //CC_XCACHE_WRAPPER_STOP_SIMULATION
-        }
-
-
-#if CC_XCACHE_WRAPPER_DEBUG_DCACHE_TRANSACTION
-        if (dreq.valid and drsp.valid)
-        {
-            log_dcache_transaction_file 
-                << "[" << m_cpt_total_cycles << "]"
-                << std::hex
-                << " @ "     << std::setw(8) << (uint32_t)dreq.addr
-                << " be "    << std::setw(1) << (uint32_t)dreq.be
-                << " W "     << std::setw(8) << (uint32_t)dreq.wdata
-                << " R "     << std::setw(8) << (uint32_t)drsp.rdata
-                << " error "            << (uint32_t)drsp.error
-                << std::dec
-                << " "  << type_str(dreq.type);
-
-            if ((dreq.type == iss_t::XTN_READ) or 
-                (dreq.type == iss_t::XTN_WRITE))
-                //log_dcache_transaction_file << xtn_str(dreq.addr>>2);
-                switch (dreq.addr>>2)
-                {
-                case iss_t::XTN_DCACHE_INVAL : log_dcache_transaction_file << " INVAL"; break;
-                case iss_t::XTN_SYNC         : log_dcache_transaction_file << " SYNC"; break;
-                default                      : log_dcache_transaction_file << " invalid"; break;
-                }                                                                            
-
-            log_dcache_transaction_file << std::endl;
-
-            // printf("[%d] @ %.8x be %.1x W %.8x R %.8x error %d - %s"
-            //        ,(uint32_t)m_cpt_total_cycles
-            //        ,(uint32_t)dreq.addr
-            //        ,(uint32_t)dreq.be
-            //        ,(uint32_t)dreq.wdata
-            //        ,(uint32_t)drsp.rdata
-            //        ,(uint32_t)drsp.error
-            //        ,type_str(dreq.type));
-            // if ((dreq.type == iss_t::XTN_READ) or 
-            //     (dreq.type == iss_t::XTN_WRITE))
-            //     //     printf(" %s",xtn_str(dreq.addr>>2));
-            //     switch (dreq.addr>>2)
-            //     {
-            //     case iss_t::XTN_DCACHE_INVAL : printf(" INVAL"); break;
-            //     case iss_t::XTN_SYNC         : printf(" SYNC"); break;
-            //     default                      : printf(" invalid"); break;
-            //     }                                                                            
-            // printf("\n");
-        }
-#endif //CC_XCACHE_WRAPPER_DEBUG_DCACHE_TRANSACTION
+
+            if (_dreq.valid and _drsp.valid)
+            {
+                log_transaction_file_dcache [num_cpu]
+                    << "[" << m_cpt_total_cycles << "]"
+                    << std::hex
+                    << " @ "     << std::setw(8) << (uint32_t)_dreq.addr
+                    << " ("      << std::setw(8) << (uint32_t)set_num_dcache_only(_dreq.addr,dreq_num_cache[num_cpu])
+                    << " - L "   << std::setw(8) <<((uint32_t)set_num_dcache_only(_dreq.addr,dreq_num_cache[num_cpu])&m_dcache_yzmask) << ")"
+                    << " be "    << std::setw(1) << (uint32_t)_dreq.be
+                    << " W "     << std::setw(8) << (uint32_t)_dreq.wdata
+                    << " R "     << std::setw(8) << (uint32_t)_drsp.rdata
+                    << " error "                 << (uint32_t)_drsp.error
+                    << std::dec
+                    << " "  << type_str(_dreq.type);
+                
+                if ((_dreq.type == iss_t::XTN_READ) or 
+                    (_dreq.type == iss_t::XTN_WRITE))
+                    //log_transaction_file_dcache [num_cpu] << xtn_str(_dreq.addr>>2);
+                    switch (_dreq.addr>>2)
+                    {
+                    case iss_t::XTN_DCACHE_INVAL : log_transaction_file_dcache [num_cpu]<< " INVAL"; break;
+                    case iss_t::XTN_SYNC         : log_transaction_file_dcache [num_cpu]<< " SYNC"; break;
+                    default                      : log_transaction_file_dcache [num_cpu]<< " invalid"; break;
+                    }
+                
+                log_transaction_file_dcache [num_cpu]<< std::endl;
+            }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+            
+            {
+                uint32_t it = 0;
+                for (size_t i=0; i<(size_t)iss_t::n_irq; i++) 
+                    if(p_irq[num_cpu][i].read()) it |= (1<<i);
+                
+                m_iss[num_cpu]->executeNCycles(1, _irsp, _drsp, it);
+            }
+        }//end num_cpu
 
         ////////////////////////////////////////////////////////////////////////////
@@ -2113,30 +3066,95 @@
 
             case CLEANUP_IDLE:
-            {    
-                if ( p_vci_ini_c.cmdack )
-                {
-                    if      (r_dcache_cleanup_req) 	r_cleanup_fsm = CLEANUP_DCACHE;
-                    else if (r_icache_cleanup_req) 	r_cleanup_fsm = CLEANUP_ICACHE;
+            {
+                uint32_t num_cache          = 0;
+                bool     cleanup_dcache_req = false;
+                bool     cleanup_icache_req = false;
+
+                // dcache is prior
+                for (uint32_t i=0; i<m_nb_dcache; ++i)
+                {
+                    PRINTF("      * <CLEANUP> dcache_cleanup_req : [%d] %d\n",i,(int)r_dcache_cleanup_req[i]);
+                    cleanup_dcache_req |= r_dcache_cleanup_req[i];
+                    if (cleanup_dcache_req)
+                    {
+                        PRINTF("      * <CLEANUP> ... find\n");
+                        num_cache=i;
+                        break;
+                    }
+                }
+ 
+                if (not cleanup_dcache_req)
+                for (uint32_t i=0; i<m_nb_icache; ++i)
+                {
+                    PRINTF("      * <CLEANUP> icache_cleanup_req : [%d] %d\n",i,(int)r_icache_cleanup_req[i]);
+
+                    cleanup_icache_req |= r_icache_cleanup_req[i];
+                    if (cleanup_icache_req)
+                    {
+                        PRINTF("      * <CLEANUP> ... find\n");
+                        num_cache=i;
+                        break;
+                    }
+                }
+
+                PRINTF("      * <CLEANUP> cleanup_icache_req : %d\n",cleanup_icache_req);
+                PRINTF("      * <CLEANUP> cleanup_dcache_req : %d\n",cleanup_dcache_req);
+                PRINTF("      * <CLEANUP> num_cache          : %d\n",num_cache);
+
+                if (cleanup_icache_req or cleanup_dcache_req)
+                {
+                    r_cleanup_fsm       = CLEANUP_REQ;
+                    r_cleanup_icache    = cleanup_icache_req;
+                    r_cleanup_num_cache = num_cache;
+
+                    PRINTF("      * <CLEANUP> address            : %llx\n",((cleanup_icache_req)?((uint64_t)set_num_icache_only(r_icache_cleanup_line[num_cache].read()<<m_icache_words_shift,num_cache)):((uint64_t)set_num_dcache_only(r_dcache_cleanup_line[num_cache].read()<<m_dcache_words_shift,num_cache))));
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                    log_transaction_file_cleanup
+                        << "[" << m_cpt_total_cycles << "] "
+                        << ((cleanup_icache_req)?("icache "):("dcache "))
+                        << num_cache << " : "
+                        << std::hex
+                        << " L "     << std::setw(10) << ((cleanup_icache_req)?((uint64_t)set_num_icache_only(r_icache_cleanup_line[num_cache].read()<<m_icache_words_shift,num_cache)):((uint64_t)set_num_dcache_only(r_dcache_cleanup_line[num_cache].read()<<m_dcache_words_shift,num_cache)))
+                        // << " (" << std::setw(10) << addr << ")"
+                        << std::dec
+                        << std::endl;
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+
                 }
                 break;
             }
-            case CLEANUP_DCACHE:
+            case CLEANUP_REQ:
+            {
+                if ( p_vci_ini_c.cmdack )
+                {
+                    if (r_cleanup_icache)
+                        r_cleanup_fsm = CLEANUP_RSP_ICACHE;
+                    else
+                        r_cleanup_fsm = CLEANUP_RSP_DCACHE;
+                }
+                break;
+            }
+            case CLEANUP_RSP_DCACHE:
             {
                 if ( p_vci_ini_c.rspval )
                 {
                     PRINTF("      * <CLEANUP> rerror : %d (%d)\n",(uint32_t)p_vci_ini_c.rerror.read(),0x2 & ( (1 << vci_param::E) - 1));
+                    PRINTF("      * <CLEANUP> rpktid : %d, r_cleanup_num_cache : %d\n",(uint32_t)p_vci_ini_c.rpktid.read(), (uint32_t)r_cleanup_num_cache);
 
                     ASSERT(p_vci_ini_c.reop and (p_vci_ini_c.rtrdid.read() == TYPE_DATA_CLEANUP),
-                            "illegal response packet received for a cleanup transaction");
+                           "illegal response packet received for a cleanup transaction");
                     ASSERT(p_vci_ini_c.rerror.read() == vci_param::ERR_NORMAL,
                            "error signaled in a cleanup response" );
-                    
+                    ASSERT(p_vci_ini_c.rpktid.read() == (sc_dt::sc_uint<vci_param::P>)r_cleanup_num_cache,
+                           "invalid pktid in a cleanup response");
+
                     r_cleanup_fsm = CLEANUP_IDLE;
-                    r_dcache_cleanup_req = false;
-                    // m_cpt_cc_cleanup_data++; TODO
+                    r_dcache_cleanup_req[r_cleanup_num_cache] = false;
+                    // m_cpt_cc_cleanup_data++;
                 }
                 break;
             }
-            case CLEANUP_ICACHE:
+            case CLEANUP_RSP_ICACHE:
             {
                 if ( p_vci_ini_c.rspval )
@@ -2150,6 +3168,6 @@
                     
                     r_cleanup_fsm = CLEANUP_IDLE;
-                    r_icache_cleanup_req = false;
-                    // m_cpt_cc_cleanup_ins++; TODO
+                    r_icache_cleanup_req[r_cleanup_num_cache] = false;
+                    // m_cpt_cc_cleanup_ins++;
                 }
                 break;
@@ -2195,7 +3213,10 @@
                 // if (r_vci_rsp_fsm != RSP_IDLE) break;
 
-                size_t	min;
-                size_t	max;
-
+                size_t	wbuf_min   = 0;
+                size_t	wbuf_max   = 0;
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                addr_40 wbuf_addr  = 0;
+                size_t  wbuf_index = 0;
+#endif
                 r_vci_cmd_cpt = 0;
 
